package rocketBugsRender;
/* 
	Pix2DColumn.... just an array of pixels with a name, color, etc
*/

/*  <RocketBugsRender - for rendering and graphing the output of Zoom (and other programs)>
    Copyright (C) <2007>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;

public class Pix2DColumn {
	DataColumn parentCol = null;
	PlotProps pProps;
	Pix2D [] pixs;
	int length;
	String name = "nameless";				// default name

	boolean annotated = false;
	String annotation = null;
	
	public Pix2DColumn (int length, DataColumn parent) {
		parentCol = parent;
		pProps = parent.pProps;
		this.length = length;
		pixs = new Pix2D[length];
	}
	
	public Pix2DColumn (Pix2D [] copyPix) {
		this.length = copyPix.length;
		for (int i=0; i<length; i++) {
			pixs[i] = new Pix2D(copyPix[i]);
		}
	}
	
	public Pix2DColumn (Pix2DColumn copyPix) {
		this.length = copyPix.length;
		for (int i=0; i<length; i++) {
			pixs[i] = new Pix2D(copyPix.pixs[i]);
		}
	}
	
	public void setParent (DataColumn parent) {
		parentCol = parent;
	}
	
	public void setName (String name) {
		this.name = name;
	}
	
	
}
	