package rocketBugsRender;
/* 	
	Plateau
*/

/*  <RocketBugsRender - for rendering and graphing the output of Zoom (and other programs)>
    Copyright (C) <2007>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.Math;

public class Plateau extends Line {
	DataColumn timeCol;
	double startTime;
	double stopTime;
	double pauseTime;
	double startVal;
	double stopVal;
	double averageVal;
	double nextStepSize;
	
	public Plateau () {}
	
	public Plateau (int startInd, int stopInd, double startVal, double stopVal, double averageVal, DataColumn timeCol) {
		this.timeCol = timeCol;
		this.start = startInd;
		this.stop= stopInd;
		this.startVal = startVal;
		this.stopVal = stopVal;
		this.averageVal = averageVal;
		this.m = (stopVal-startVal)/(stop-start);
		findTimes ();
		
	}
	
	private void findTimes () {
		startTime = timeCol.data[start];
		stopTime = timeCol.data[stop];
		pauseTime = stopTime-startTime;
	}
	
	public double [] getAllVals() {
		int numVals = stop-start+1;
		double [] vals = new double [numVals];
		for (int i=0;i<numVals;i++) {
			vals[i] = getAveVal();
		}
		return vals;
	}
	
	public double getAveVal () {
		// send back value of y for a particular x
		return averageVal;
	}
	
	public double getStartVal () {
		return startVal;
	}
	
	public double getStopVal () {
		return stopVal;
	}
	
	public void subsume (Plateau pac) {
		int runLength = (stop-start) + (pac.stop-pac.start);
		averageVal = ((stop-start)*averageVal + (pac.stop-pac.start)*pac.averageVal)/runLength;
		if (pac.start < start) {
			start = pac.start;
			startVal = pac.startVal;
		}
		if (stop < pac.stop) {
			stop = pac.stop;
			stopVal = pac.stopVal;
		}
		m = (stopVal-startVal)/(stop-start);
		findTimes();
	}
			
	
}